/*
roprog 1.03
by An Eyewitness
aneyewitness@geocities.com
Autumn 98
*/

import java.net.*;
import java.io.*;

class roprog implements Runnable{

  String ip;
  static int port;
  static int maxport;
  int t_port; // non-static port for each thread
  static byte init_packet[] = new byte[128];
  static byte msg_packet[] = new byte[128];
  static int t_number = 0;

  byte reply_packet[] = new byte[128];
  int read;

  public static void main(String args[]){

    init_packet[0] = (byte) 0x1A;
    init_packet[2] = (byte) 0xFF;
    init_packet[3] = (byte) 0x02;

    init_packet[11] = (byte) 0xFA; // friend of mine
    init_packet[12] = (byte) 0xEA;
    init_packet[13] = (byte) 0x46;
   
    msg_packet[2] = (byte) 0xFA;
    msg_packet[3] = (byte) 0xEA;
    msg_packet[4] = (byte) 0x46;
    msg_packet[6] = (byte) 0x02;
    msg_packet[8] = (byte) 0xEE;
    msg_packet[9] = (byte) 0x07;
    msg_packet[12] = (byte) 0xFA;
    msg_packet[13] = (byte) 0xEA;
    msg_packet[14] = (byte) 0x46;
    msg_packet[16] = (byte) 0xEA;
    msg_packet[17] = (byte) 0x03;
    msg_packet[18] = (byte) 0x01;
    msg_packet[36] = (byte) 0x10; 
    msg_packet[0] = (byte) 41;

    System.out.println("Roprog 1.03 by An Eyewitness");

    if(args.length!=3){
      System.out.println("Usage: roprog <IP> <starting port> <maximum port>");
    }
    else{

      try{
	InetAddress.getByName(args[0]);
      }
      catch(UnknownHostException ex){
	System.out.println("Host " + ex.getMessage() + " is unknown");
	System.exit(1);
      }

      try{
      port = Integer.parseInt(args[1]) -1;
      maxport = Integer.parseInt(args[2]);
      }
      catch(NumberFormatException ex){
	System.out.println(ex.getMessage() + " is not a valid port");
	System.exit(1);
      }

      for(int t=0;t<25;t++){
	Thread thread = new Thread(new roprog(args[0]));
	thread.start();
      }
    }
  }
  
  public roprog(String ip){
    t_number++;
    this.ip = ip;
    nextport();
  }

  public void run(){

    do{
      try{
	Socket socket = new Socket(ip, t_port);
	get_uin(socket);
	nextport();
	socket.close();
      }
      catch(InterruptedIOException ex){
	System.out.println("Socket timed out");
	nextport();
      }
      catch(ConnectException ex){
	nextport();
      }
      catch(NoRouteToHostException ex){
	synchronized(System.err){
	  System.err.println("Can't contact " + ip.toString() + ". Are you sure the IP address is (still) online?");
	  System.err.println("Last scaned port was " + t_port);
	  System.exit(1);
	}
      }
      catch(IOException ex){
	synchronized(System.err){
	  ex.printStackTrace();
	}
      }
    }while(port<=maxport);
    t_number--;
    if(t_number==0)
      System.out.println("Done.");
  }

  void get_uin(Socket socket) throws IOException{

    socket.setSoTimeout(30000);

    BufferedInputStream reader = new BufferedInputStream(socket.getInputStream());
    BufferedOutputStream writer = new BufferedOutputStream(socket.getOutputStream());
    synchronized(System.out){
      System.out.print("Port " + socket.getPort()+ " is open. ");
      writer.write(init_packet, 0, 28);
      writer.write(msg_packet, 0, 43);
      writer.flush();
      
      reader.read(reply_packet, 0, 1);
      reader.read(reply_packet, 1, 1);
      read = reader.read(reply_packet, 2, 126);
      if(read!=-1)
	System.out.print("Received " + (read + 2) + " bytes : ");
      if(read>10){
	String uin = new String("");
	String uin2 = new String("");
	for(int i=5;i>1;i--){
	  Byte reply = new Byte(reply_packet[i]);
	  String uin_byte = Integer.toHexString(reply.intValue());
	  if(uin_byte.length()==1)
	    uin_byte = new String("0" + uin_byte);
	  else if(uin_byte.length()>2)
	    uin_byte = uin_byte.substring(uin_byte.length()-2);
	  uin = uin.concat(uin_byte);
	}
	for(int i=15;i>11;i--){
	  Byte reply = new Byte(reply_packet[i]);
	  String uin_byte = Integer.toHexString(reply.intValue());
	  if(uin_byte.length()==1)
	    uin_byte = new String("0" + uin_byte);
	  else if(uin_byte.length()>2)
	    uin_byte = uin_byte.substring(uin_byte.length()-2);
	  uin2 = uin2.concat(uin_byte);
	}
	if(uin.equals(uin2)) // check if the 2 uin fields of the packet are the same
	  System.out.println("UIN seems to be " + Integer.toString(Integer.parseInt(uin, 16)));
	else
	  System.out.println("Not an ICQ port.");
      }
      else{
	System.out.println("Not an ICQ port.");
      }
    }
  }

  synchronized void nextport(){
    t_port = ++port;
  }

} 







